{% extends "base-volunteer-details.html" %}
{% load seawatch_registration_tags %}
{% block profile-content %}
  <h1>Documents</h1>
  <form method="post" style="margin-bottom: 50px;">
    {% csrf_token %}
    <div style="display: flex; justify-content: space-between;">
      <div>
        <button class="btn btn-primary btn-sm"
                type="submit"
                name="action"
                data-active-on-many
                disabled
                value="archive">Archive</button>
        <button class="btn btn-primary btn-sm"
                type="submit"
                data-active-on-one
                name="action"
                disabled
                value="edit">Edit</button>
      </div>
    </div>
    <div style="display: flex; justify-content: space-between;">
      <div>
        <p>Select documents to perform actions on them.</p>
      </div>
      <div>
        <a class="button"
           href="{% url "volunteer_document_create" volunteer_id=volunteer.id %}">Upload</a>
        <button class="button" type="button">
          Request documents
          <script>
            document.currentScript.parentElement.addEventListener('click', () => {
              document.getElementById('volunteer-request-rank-related-documents-dialog').classList.add('visible')
            });
          </script>
        </button>
      </div>
    </div>
    <dl>
      {% for type, docs in documents_grouped %}
        <dt>{{ type.label }}</dt>
        {% for document in docs %}
          <dd>
            <input name="document"
                   value="{{ document.id }}"
                   type="checkbox"
                   style="margin-right: 5px"
                   onclick="update_enabled_buttons(this.form)" />
            <a target="_blank" href="{{ document.file.url }}">{{ document.file|basename }}</a>
            {% if document.valid_until %}(valid until: {{ document.valid_until|date:"SHORT_DATE_FORMAT" }}){% endif %}
          </dd>
        {% endfor %}
      {% endfor %}
    </dl>
  </form>
  <form method="post" style="margin-bottom: 50px;">
    {% csrf_token %}
    <h2 style="margin-top:50px;">Archived Documents</h2>
    {% if archived %}
      <div style="display: flex; justify-content: space-between;">
        <div>
          <button class="btn btn-primary btn-sm"
                  type="submit"
                  name="action"
                  data-active-on-many
                  disabled
                  value="unarchive">Unarchive</button>
          <button class="btn btn-primary btn-sm"
                  type="button"
                  disabled
                  id="delbtn"
                  data-active-on-many
                  onclick="toggle_confirm_delete_button()">Delete</button>
          <button class="btn btn-danger btn-sm hidden"
                  type="submit"
                  id="delconfirmbtn"
                  name="action"
                  value="delete">Confirm delete</button>
        </div>
      </div>
      <div style="display: flex; justify-content: space-between;">
        <div>
          <p>Select documents to perform actions on them.</p>
        </div>
      </div>
      <dl>
        {% for document in archived %}
          <dd>
            <input name="document"
                   value="{{ document.id }}"
                   type="checkbox"
                   style="margin-right: 5px"
                   onclick="update_enabled_buttons(this.form)">
            <a target="_blank" href="{{ document.file.url }}">{{ document.file|basename }}</a>
            {% if document.valid_until %}(valid until: {{ document.valid_until|date:"SHORT_DATE_FORMAT" }}){% endif %}
          </dd>
        {% endfor %}
      </dl>
    {% else %}
      <div>No archived documents</div>
    {% endif %}
  </form>
  <script>
      const set_button = (form, buttons_to_change, enabled) => {
        for (const btn of form.querySelectorAll(`[data-active-on-${buttons_to_change}]`))
            btn.disabled = !enabled;
      }

      function update_enabled_buttons(form) {
        const checkboxes = form.getElementsByTagName("input");
        let count = 0;

        for (let box of checkboxes)
          if (box.checked === true)
            count++;

        if (count > 0) {
          set_button(form, "many", true);
          if (count == 1) {
            set_button(form, "one", true);
          } else
            set_button(form, "one", false);
        } else {
          set_button(form, "one", false);
          set_button(form, "many", false);
        }
      }

      var confirm_delete_button_armed = false;
      function toggle_confirm_delete_button() {
        document.getElementById("delconfirmbtn").style.display = confirm_delete_button_armed ? "none" : "inline-block";
        document.getElementById("delbtn").innerHTML = confirm_delete_button_armed ? "Delete" : "Cancel";
        confirm_delete_button_armed = !confirm_delete_button_armed;
      }
  </script>
{% endblock %}
{% block extra_body_content %}
  {% include "volunteers/volunteer_request_rank_related_documents_dialog.html" %}
{% endblock %}
